#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 


typedef long	(__stdcall *VeryEncryptPDFFunc)(const char * inFileName, const char *outFileName, 
			   long EnctyptLen, long permission, 
			   const char *OwnerPassword, const char *UserPassword);
typedef long	(__stdcall *VeryDecryptPDFFunc)(const char * inFileName, const char *outFileName,
			   const char *OwnerPassword, const char *UserPassword);
typedef BOOL	(__stdcall *VeryIsPDFEncryptedFunc)(const char * inFileName);
typedef BOOL	(__stdcall *VeryTestEncryptedPDFFunc)(const char * inFileName,const char *OwnerPassword, 
				 const char *UserPassword);
typedef void	(__stdcall *VerySetLicenseKeyFunc)(const char* lpszLicenseKey);
typedef int		(__stdcall *VeryGetPermissionFromPDFFileFunc)(const char * inFileName);

HMODULE						g_hVeryW = NULL;
VeryEncryptPDFFunc			VeryEncryptPDF = NULL;
VeryDecryptPDFFunc			VeryDecryptPDF = NULL;
VeryIsPDFEncryptedFunc		VeryIsPDFEncrypted = NULL;
VeryTestEncryptedPDFFunc	VeryTestEncryptedPDF = NULL;
VerySetLicenseKeyFunc		VerySetLicenseKey = NULL;
VeryGetPermissionFromPDFFileFunc VeryGetPermissionFromPDFFile = NULL;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadVeryWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"verywrite.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
		goto Failer;

	VeryEncryptPDF=(VeryEncryptPDFFunc)GetProcAddress(g_hVeryW,"VeryEncryptPDF");
	if(VeryEncryptPDF==NULL)
		goto Failer;
	VeryDecryptPDF=(VeryDecryptPDFFunc)GetProcAddress(g_hVeryW,"VeryDecryptPDF");
	if(VeryDecryptPDF==NULL)
		goto Failer;
	VeryIsPDFEncrypted=(VeryIsPDFEncryptedFunc)GetProcAddress(g_hVeryW,"VeryIsPDFEncrypted");
	if(VeryIsPDFEncrypted==NULL)
		goto Failer;
	VeryTestEncryptedPDF=(VeryTestEncryptedPDFFunc)GetProcAddress(g_hVeryW,"VeryTestEncryptedPDF");
	if(VeryTestEncryptedPDF==NULL)
		goto Failer;
	VerySetLicenseKey = (VerySetLicenseKeyFunc)GetProcAddress(g_hVeryW,"VerySetLicenseKey");
	if(VerySetLicenseKey == NULL)
		goto Failer;
	VeryGetPermissionFromPDFFile = (VeryGetPermissionFromPDFFileFunc)GetProcAddress(g_hVeryW,"VeryGetPermissionFromPDFFile");
	if(VeryGetPermissionFromPDFFile == NULL)
		goto Failer;
	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;

}

void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}

long GetPermission(BOOL Print,BOOL Copy,BOOL Modify,BOOL EnableAcroFormFields)
{
	long permission = 0;

	if(Print)
		permission |= 0x04;
	if(Copy)
		permission |= 0x10;
	if(Modify)
		permission |= 0x08;
	if(EnableAcroFormFields)
		permission |= 0x20;

	return permission;
}

void DecryptPDFFiles()
{
	char srcpath[_MAX_PATH];
	char despath[_MAX_PATH];
	int nNewPermission = 0;

	memset(srcpath,0,_MAX_PATH);
	memset(despath,0,_MAX_PATH);

	//example 1
	GetModulePath(srcpath,"test1Encrypt.pdf");
	GetModulePath(despath,"test1Decrypt.pdf");
	if(VeryIsPDFEncrypted(srcpath))
		VeryDecryptPDF(srcpath,despath,"owner","user");
	nNewPermission = VeryGetPermissionFromPDFFile(despath);
	printf("'%s', Permission=%d\n", despath, nNewPermission);

	//example 2
	GetModulePath(srcpath,"test2Encrypt.pdf");
	GetModulePath(despath,"test2Decrypt.pdf");
	if(VeryIsPDFEncrypted(srcpath))
		VeryDecryptPDF(srcpath,despath,"owner","user");
	nNewPermission = VeryGetPermissionFromPDFFile(despath);
	printf("'%s', Permission=%d\n", despath, nNewPermission);
}
void EncryptPDFFiles()
{
	int encyptlevel,permission=0;
	char srcpath[_MAX_PATH];
	char despath[_MAX_PATH];
	BOOL bIsSucceed = FALSE;
	int nNewPermission = 0;

	memset(srcpath,0,_MAX_PATH);
	memset(despath,0,_MAX_PATH);

	//example 1
	GetModulePath(srcpath,"test1.pdf");
	GetModulePath(despath,"test1Encrypt.pdf");
	encyptlevel=128;
	permission=GetPermission(TRUE,TRUE,TRUE,TRUE);
	VeryEncryptPDF(srcpath,despath,encyptlevel,permission,"owner","user");
	bIsSucceed = VeryTestEncryptedPDF(despath,"owner","user");
	nNewPermission = VeryGetPermissionFromPDFFile(despath);
	printf("'%s', Permission=%d\n", despath, nNewPermission);

	//example 2
	GetModulePath(srcpath,"test2.pdf");
	GetModulePath(despath,"test2Encrypt.pdf");
	encyptlevel=40;
	permission=GetPermission(FALSE,FALSE,FALSE,FALSE);
	VeryEncryptPDF(srcpath,despath,encyptlevel,permission,"owner","user");
	bIsSucceed = VeryTestEncryptedPDF(despath,"owner","user");

	nNewPermission = VeryGetPermissionFromPDFFile(despath);
	printf("'%s', Permission=%d\n", despath, nNewPermission);
}
void main()
{
	if(!LoadVeryWDll())
		return;

	VerySetLicenseKey("XXXXXXXXXXXXXXXXXXX");
	EncryptPDFFiles();
	DecryptPDFFiles();

	FreeVeryWDll();
}